/************************************************************************
Main.cpp - SpaceGame main file

Written by Zero (xmaste00).

THIS SOFTWARE IS NOT COPYRIGHTED

This source code is offered for use in the public domain.
You may use, modify or distribute it freely.

This source code is distributed in the hope that it will be useful but
WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
DISCLAIMED.  This includes but is not limited to warranties of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

If you find the source code useful, authors will kindly welcome
if you give them credit and keep their names with their source code,
but you are not forced to do so.
************************************************************************/

#ifdef _MSC_VER
#pragma comment(linker, "/entry:\"mainCRTStartup\"") // Linker will link
// the application using main(), not WinMain (as usual on Windows).
#pragma comment(linker, "/subsystem:\"CONSOLE\"") // show console
#endif

#include "Main.h"
#include "SgoManager.h"
#include "SgInterface.h"

HWND window;
SoWinRenderArea * renderArea;

static SgoManager * sgoManager;		// manazer objektu
SgObject * sgo;						// objekt

SgMouse * mouse;
SgKeyboard * keyboard;
SgCamera * kamera;
SoMouseButtonEvent * mouseEvent;
SoKeyboardEvent * keyEvent;

int countID=0;	// ID pro objekty

int kameraC=0;
int kameraX=0;
bool kameraSel=true;
bool Abs=false;
bool Rel=false;
bool RelDamp=true;
bool MouseControl=false;


void onMouseButton(void *userdata, SoEventCallback * node){
	const SoEvent * event = node->getEvent();
//	SoMouseButtonEvent::Button butt = mouseEvent->getButton();
	mouse->setButton(event);
	node->setHandled();
}

void onKeyPress(void *userdata, SoEventCallback * node){
	const SoEvent * event = node->getEvent();
//	SoKeyboardEvent::Key k = keyEvent->getKey();
	keyboard->setKey(event);
	node->setHandled();
}

static void timeStep(void *data, SoSensor *sensor)
{
	static SbTime lastTime = SbTime::zero();
	SbTime ct = SbTime::getTimeOfDay();
	SbTime dt;
	if (lastTime == SbTime::zero()) {
		lastTime = ct;
		dt = SbTime::zero();
	} else {
		dt = ct - lastTime;
		lastTime = ct;
	}
	if (dt.getValue()>0.1) dt=0.1f;
	//vyhodnoceni vsech objektu
	sgoManager->timeStep(ct.getValue(), dt.getValue());
	
	if ((keyboard->getKey(keyH))||(keyboard->getKey(keyF1)))			// napoveda
	{
		MessageBox(window,
			"Tuto npovdu vyvolte optovnm stisknutm klavesy H/h nebo F1\n"
			"\n"
			"Volba ovldn:\n"
			"Relativn (mn se psobc sla na tleso)			1\n"
			"Relativn s autopilotem (default)				2\n"
			"\n"
            "Pepnut mezi klavesnic a my (default=klavesnice)		M/m\n"
			"\n"
			"Ovldn sthaky: \n"
			"Stelba				F, lev tlatko myi\n"
			"Ovldn translace			A,S,W,D (Q-Nahoru,E-Dolu)\n"
			"Ovldn rotace ipkami		Kursorove ipky (CTRL+Left/Right - rotace kolem smrov osy)\n"
			"Ovldn rotace my		My (CTRL+My - rotace kolem smrov osy)\n"
			"Zastaven vekerho pohybu (ekvivalent run brzd)	SPACE\n"			
			"\n"
			"Ostatni nastaven:\n"
			"\n"
			"Zven odporu prosted		T\n"
			"Snen odporu prosted		R\n"
			"Pepnn kamery			V\n"
			"Pozice kamery			X,C\n"
			"Pozice kamery (cileni)		Tab\n"
			"\n"
			,"Start hry - Kolo 1 - npovda",MB_OK);	
		keyboard->falseKey(keyH);
		keyboard->falseKey(keyF1);
	}
	static v=false;
	if (keyboard->getKey(keyV))			// volna kamera
	{
		if (!v) {
			kameraSel=!kameraSel;
			if (kameraSel)
			{
				sgoManager->setActiveFree();
				kamera->setDistance(0);
				kamera->setHeight(0);
			}else 
			{
				sgoManager->setActiveFighter();
				kameraC=16;
				kameraX=1;
				kamera->setDistance(16);
				kamera->setHeight(1);
			}
		}
		v=true;
	}else v=false;
	static c=false;
	if (keyboard->getKey(keyC))			// kamera upnuta na stihacku
	{
		if (!c)
		{
			kamera->setDistance(kameraC);
			kameraC+=2;
			if (kameraC>30)kameraC=0; ;
		}
		c=true;
	}else c=false;
	static x=false;
	if (keyboard->getKey(keyX))			// kamera upnuta na stihacku
	{
		if (!x)
		{
			kamera->setHeight(kameraX);
			kameraX+=1;
			if (++kameraX>8)kameraX=-8; ;
		}
		x=true;
	}else x=false;
	if (keyboard->getKey(keyTAB))		// zacileni
	{
		kamera->setDistance(8);
		kamera->setHeight(-2);
	}else
	{
		kamera->setDistance(kameraC);
		kamera->setHeight(kameraX);
	}
	static dampt=false;
	if (keyboard->getKey(keyT))										// tlumeni
	{
		if(!dampt)
		{
			if (sgoManager->getDamp() < 1) 
			{
				sgoManager->setDamp(sgoManager->getDamp()+0.1f);
				cout<<"Tlumeni: "<<sgoManager->getDamp()<<endl;
			}
		}
		dampt=true;
	}else dampt=false;
	
	static dampr=false;
	if (keyboard->getKey(keyR))										// tlumeni
	{
		if(!dampr)
		{
			if (sgoManager->getDamp() > 0) 
			{
				sgoManager->setDamp(sgoManager->getDamp()-0.1f);
				cout<<"Tlumeni: "<<sgoManager->getDamp()<<endl;
			}
		}
		dampr=true;
	}else dampr=false;

	static fire=false;
	if ((mouse->getButton(Mouse1))||(keyboard->getKey(keyF)))		// strelba 
	{
		if (!fire)
		{
			cout<<"Start missile"<<endl;
			sgo = new SgObject;	
			sgo->setTypeBB(SgObject::SPHERE);
			sgo->setType(SgObject::MISSILE);
			sgo->setID(countID++);
			cout<<"ID: "<<countID<<endl;
			sgo->setPos(sgoManager->getActive()->getPos()-2*sgoManager->getActive()->getUpVec());
			sgo->setOrientation(sgoManager->getActive()->getOrientation());
			sgo->updOrientation(sgoManager->getActive()->getLeftVec(),M_PI/2.f);
			sgo->setSpeed(sgoManager->getActive()->getSpeed()+sgoManager->getActive()->getDirVec()*50);
			sgo->setScale(SbVec3f(1,1,1)*0.02f);
			sgo->setMass(10);
			sgo->setModel("Missile.wrl");
			sgoManager->appendSgo(sgo);
		}
		fire=true;
	} else fire=false;
/*	if (keyboard->getKey(key3))										// absolutni pohyb
	{
		Abs=true;
		Rel=false;
		RelDamp=false;
	}*/
	if (keyboard->getKey(key1))										// relativni pohyb
	{
		Abs=false;
		Rel=true;
		RelDamp=false;
	}
	if (keyboard->getKey(key2))										// relativni pohyb s utlumem
	{
		Abs=false;
		Rel=false;
		RelDamp=true;
	}
	static mouse=false;
	if (keyboard->getKey(keyM))										// prepnuti rotace
	{
		if (!mouse) MouseControl=!MouseControl;
		mouse=true;
	}else mouse=false;

	if (sgoManager->getActive()!=NULL)			// pracuju jen s vzbranym objektem
	{
		if (keyboard->getKey(keySpace))					// uplne zastaveni
		{
			sgoManager->getActive()->setVel(0,0,0);
			sgoManager->getActive()->setAngVel(0,0,0);
		}
		float speed=1.f;
		if (Abs)										// absolutni pohyb
		{
			if (keyboard->getKey(keyW)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()+sgoManager->getActive()->getDirVec()*speed);
			if (keyboard->getKey(keyS)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()-sgoManager->getActive()->getDirVec()*speed);
			if (keyboard->getKey(keyA)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()+sgoManager->getActive()->getLeftVec()*speed);
			if (keyboard->getKey(keyD)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()-sgoManager->getActive()->getLeftVec()*speed);
			if (keyboard->getKey(keyQ)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()+sgoManager->getActive()->getUpVec()*speed);
			if (keyboard->getKey(keyE)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()-sgoManager->getActive()->getUpVec()*speed);
			sgoManager->getActive()->setSpeed(sgoManager->getActive()->getPos()-sgoManager->getActive()->getOldPos());
		}
		if (Rel || RelDamp)								// relativni pohyb
		{
			if (keyboard->getKey(keyW)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()+sgoManager->getActive()->getDirVec()*speed);
			if (keyboard->getKey(keyS)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getDirVec()*speed);
			if (keyboard->getKey(keyA)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()+sgoManager->getActive()->getLeftVec()*speed);
			if (keyboard->getKey(keyD)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getLeftVec()*speed);
			if (keyboard->getKey(keyQ)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()+sgoManager->getActive()->getUpVec()*speed);
			if (keyboard->getKey(keyE)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getUpVec()*speed);
		}
		if (RelDamp)									// tlumeni
		{
			if (!(	keyboard->getKey(keyW)||keyboard->getKey(keyS)||keyboard->getKey(keyA)||
					keyboard->getKey(keyD)||keyboard->getKey(keyQ)||keyboard->getKey(keyE)))
			{
				float size=sgoManager->getActive()->getVel().length();
				if (size>speed)
					sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getDirVel()*speed/2.f);
				else sgoManager->getActive()->setVel(0,0,0);
			}
		}
		speed/=10.f;
		float size=sgoManager->getActive()->getAngVel().length();
		if (MouseControl)
		{												// ovladani mysi
  			RECT a; 
			POINT p;  
			GetWindowRect(window, &a);
			GetCursorPos(&p);
			float Sx=a.left+(a.right-a.left)/2.f;
			float Sy=a.top+(a.bottom-a.top)/2.f;
			float moveX=(Sx-p.x)/180.f*speed*10;
			float moveY=-(Sy-p.y)/180.f*speed*10;
			if (Abs)									// absolutni
			{
				if (!keyboard->getKey(keyCTRL)) sgoManager->getActive()->RotLR(moveX);
				else 
					sgoManager->getActive()->RotAR(moveX);
				sgoManager->getActive()->RotUD(moveY);
  			}
			if (Rel || RelDamp)							// relativni
			{
				if (!keyboard->getKey(keyCTRL)) sgoManager->getActive()->TorqueLR(-moveX);
				else 
					sgoManager->getActive()->TorqueAR(-moveX);
				sgoManager->getActive()->TorqueUD(-moveY);
  			}
			if (RelDamp)								// tlumeni
			{
				if ((moveX==0)&&(moveY==0))
				{
					if (size>size/10.f)
						sgoManager->getActive()->setAngVel(sgoManager->getActive()->getAngVel()-((sgoManager->getActive()->getAngVel()*speed)/6.f));
					else sgoManager->getActive()->setAngVel(0,0,0);
				}
			}
			SetCursorPos(Sx,Sy);
		}else											// ovladani klavesnici
		{
			if (Abs)
			{
				speed/=10;
				if (keyboard->getKey(keyLeft))
					if (!keyboard->getKey(keyCTRL)) sgoManager->getActive()->RotLR(speed);
					else sgoManager->getActive()->RotAR(-speed);
				if (keyboard->getKey(keyRight))
					if (!keyboard->getKey(keyCTRL)) sgoManager->getActive()->RotLR(-speed);
					else sgoManager->getActive()->RotAR(speed);
				if (keyboard->getKey(keyUp)) sgoManager->getActive()->RotUD(-speed);
				if (keyboard->getKey(keyDown)) sgoManager->getActive()->RotUD(speed);
				speed*=10;
 			}
			if (Rel || RelDamp)
			{
				speed/=10;
				if (keyboard->getKey(keyLeft))
					if (!keyboard->getKey(keyCTRL)) sgoManager->getActive()->TorqueLR(-speed);
					else sgoManager->getActive()->TorqueAR(-speed);
				if (keyboard->getKey(keyRight))
					if (!keyboard->getKey(keyCTRL)) sgoManager->getActive()->TorqueLR(speed);
					else sgoManager->getActive()->TorqueAR(speed);
				if (keyboard->getKey(keyUp)) sgoManager->getActive()->TorqueUD(speed);
				if (keyboard->getKey(keyDown)) sgoManager->getActive()->TorqueUD(-speed);
				speed*=10;
 			}
			if (RelDamp)									// tlumeni
			{
				if (!(	keyboard->getKey(keyLeft)||keyboard->getKey(keyRight)||
						keyboard->getKey(keyUp)||keyboard->getKey(keyDown)))
				{
					if (size>size/10.f)
						sgoManager->getActive()->setAngVel(sgoManager->getActive()->getAngVel()-((sgoManager->getActive()->getAngVel()*speed)/6.f));
					else sgoManager->getActive()->setAngVel(0,0,0);
				}
			}
		}
	}
	if (sgoManager->destroy()) 
	{
		MessageBox(window,"Fighter znicen raketou","Konec",MB_OK);	
		exit(0);
	}else
	{
		kamera->setRot(sgoManager->getActive()->getCameraOrientation());
		kamera->setPos(sgoManager->getActive()->getPos());
	}
	
	sensor->schedule();
}

float UnitRandom(int max)
{
	return ((rand()%100)/100.f)*max;
}

int main(int argc, char **argv)
{
	// Inicializace nahodnych cisel
	srand((unsigned int)time(NULL) + getpid());

	// Inicializace inventoru
	window = SoWin::init(argc, argv, argv[0]);
	if (window == NULL)  exit(1);

	// Adresare
	SoInput::addDirectoryFirst("data/textures/");
	SoInput::addDirectoryFirst("data/meshes/");

	// Scene root
	SoSeparator * root = new SoSeparator;
	root->ref();

	#if 0	// 0/1 vypne/zapne zobrazeni textur
		SoComplexity *complexity = new SoComplexity;
		complexity->value = 0.f;
		complexity->textureQuality = 0.f;
		root->addChild(complexity);
	#endif

	mouse = new SgMouse;				// trida ovladani mysi
	keyboard = new SgKeyboard;			// trida ovladani klavesnici
	mouseEvent = new SoMouseButtonEvent;// obsluha udalosti mysi
	keyEvent = new SoKeyboardEvent;		// obsluha udalosti klavesnice
	
	
	kamera = new SgCamera;				// trida kamery
	kamera->setDistance(0);
	kamera->setHeight(0);
	root->addChild(kamera->getRoot());

	// Svtla
	SoDirectionalLight * svetlo0=new SoDirectionalLight;	// globalni svetlo
	svetlo0->direction.setValue(0.0f, 0.0f, -1.0f);
	svetlo0->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo0->intensity = 0.3f;
	root->addChild(svetlo0);
	SoDirectionalLight * svetlo1=new SoDirectionalLight;	// globalni svetlo
	svetlo1->direction.setValue(0.0f, 0.0f, 1.0f);
	svetlo1->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo1->intensity = 0.3f;
	root->addChild(svetlo1);
	SoDirectionalLight * svetlo2=new SoDirectionalLight;	// globalni svetlo
	svetlo2->direction.setValue(0.0f, 1.0f, 0.0f);
	svetlo2->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo2->intensity = 0.3f;
	root->addChild(svetlo2);
	SoDirectionalLight * svetlo3=new SoDirectionalLight;	// globalni svetlo
	svetlo3->direction.setValue(0.0f, -1.0f, 0.0f);
	svetlo3->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo3->intensity = 0.3f;
	root->addChild(svetlo3);
	SoDirectionalLight * svetlo4=new SoDirectionalLight;	// globalni svetlo
	svetlo4->direction.setValue(1.0f, 0.0f, 0.0f);
	svetlo4->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo4->intensity = 0.3f;
	root->addChild(svetlo4);
	SoDirectionalLight * svetlo5=new SoDirectionalLight;	// globalni svetlo
	svetlo5->direction.setValue(-1.0f, 0.0f, 0.0f);
	svetlo5->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo5->intensity = 0.3f;
	root->addChild(svetlo5);

    // svetlo pro stihacku
	
	SgPointLight * pointLight = new SgPointLight;
	pointLight->setRoot(root);

	/*SgConeLight * coneLight = new SgConeLight;
	coneLight->setRoot(root);*/


	/*SoPointLight * svetlo1=new SoPointLight;		// bodove
	svetlo1->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo1->location = SbVec3f(0,0,0);
	svetlo1->intensity = 1;
	root->addChild(svetlo1);*/

	// SpaceGame Object Manager
	sgoManager = new SgoManager;
	sgoManager->setCamera(kamera->getRoot());		// predani kamery pro manazer
	root->addChild(sgoManager->getSgoRoot());		// pridani manazeru do sceny
	
	//////////// Definice objektu ///////////////////////////////
	//sgo = new SgObject;										// vytvoreni noveho objektu
	//sgo->setTypeBB();			// default:AABB
	//sgo->setTypeCollision();	// default:BODY
	//sgo->setType();			// default:OTHER
	//sgo->setReference();		// default:false
	//sgo->setStatic();			// default:false
	//sgo->setID(count++);		// default:0					// nutne zadat !!!					
	//sgo->setSphereRadius();	// default:1					// vhodne zadat					// bud SPHERE nebo AABB, druhe se dopocita
	//sgo->setActionRadius();	// default:1					// zadat pro referencni teleso	// nebo se oboji nacte ze souboru
	//sgo->setFieldAABB();		// default:[-1,-1,-1],[1,1,1]	// vhodne zadat					// bud SPHERE nebo AABB, druhe se dopocita
	//sgo->setFieldAAAB();		// default:[-1,-1,-1],[1,1,1]	// zadat pro referencni teleso	// nebo se oboji nacte ze souboru
	//sgo->setMass();			// default:10					// vhodne zadat
	//sgo->setCoefficientOfRestitution();// default:1
	//sgo->setPos();			// default:(0,0,0)				// vhodne zadat
	//sgo->setSpeed();			// default:(0,0,0)				// vhodne zadat
	//sgo->setAngVel();			// default:(0,0,0)				// vhodne zadat
	//sgo->setAngMom();			// default:(0,0,0)
	//sgo->setInertiaTensor();	// default:diagonalni matice	// nutne zadat pro spravnou funkci vyhodnocovani srazky dvou pevnych teles (BODY)
	//sgo->setModel(,);											// nutne zadat
	//sgo->setScale();											// vhodne upravit meritko
	//sgo->updOrientation();									// natoci teleso
	//sgoManager->appendSgo(sgo);								// pridani objektu do manazeru
	////////////////////////////////////////////////////////////

	/////////// definice vsech objektu ve scene ///////////
	float tunnelScale=0.1f;// meritko Tunelu
	float scale=0.01f;
	
	ifstream zdroj;
	string cube;			// druh kostky
	int posX=0;				// pozice kostky v X-ove ose
	int posY=0;				// pozice kostky v Y-ove ose
	int posZ=0;				// pozice kostky v Z-ove ose
	SbVec3f rotAxis(0,0,0);	// osa rotace
	float a=0;				// strana kostky
	SbVec3f tran(0,0,0);	// pozice telesa uvnitr kostky
	float rot=0;			// rotace

	char ch;

	zdroj.open("data/tunel.txt");
	while (zdroj.is_open() && !zdroj.eof())
	{
		zdroj >> cube;			// nacteni druhu kostky
		if (cube != "/*")
		{
			zdroj >> ch;			// "("
			zdroj >> posX;			// pozice X
			zdroj >> posY;			// pozice Y
			zdroj >> posZ;			// pozice Z
			zdroj >> ch;			// ")"
			zdroj >> ch;			// "("
			zdroj >> rotAxis[0];	// osa rotace
			zdroj >> rotAxis[1];
			zdroj >> rotAxis[2];
			zdroj >> ch;			// ")"
			zdroj >> rot;			// rotace
			sgo = new SgObject;
			sgo->setReference(true);
			sgo->setStatic(true);
			sgo->setType(SgObject::OBJECT);
			sgo->setID(countID++);
			sgo->setPos(posX*500*tunnelScale,posY*500*tunnelScale,posZ*500*tunnelScale);
			sgo->setScale(SbVec3f(1,1,1)*tunnelScale);
			if (cube=="S") 
			{
				sgo->setModel("CubeS.wrl");
				sgo->setOrientation(rotAxis,rot*(float)M_PI);	// otocim podle souboru kostku I
			}
			if (cube=="I") 
			{
				sgo->setModel("CubeI.wrl");
				sgo->setOrientation(rotAxis,rot*(float)M_PI);	// otocim podle souboru kostku I
			}
			if (cube=="L") 
			{
				sgo->setModel("CubeL.wrl");
				sgo->setOrientation(SbVec3f(1,0,0),3/2.0f*(float)M_PI);	// otoceni do zakladni polohy L
				sgo->updOrientation(rotAxis,rot*(float)M_PI);				// otoceni podle souboru kostku L
			}
			if (cube=="R")
			{
				sgo->setModel("CubeL.wrl");
				sgo->setOrientation(SbVec3f(1,0,0),3/2.0f*(float)M_PI);	// otoceni do zakladni polohy L
				sgo->updOrientation(SbVec3f(0,0,1),(float)M_PI);		// otoceni do zakladni polohy R
				sgo->updOrientation(rotAxis,rot*(float)M_PI);			// otoceni podle souboru kostku R
			}
			a=sgo->getOneAABB(3);
			sgoManager->appendSgo(sgo);
			zdroj >> cube;
			while (!(cube == "END"))	// staticke telesa
			{
				zdroj >> ch;			// "("
				zdroj >> tran[0];		// pozice telesa
				tran[0]*=a;
				zdroj >> tran[1];		// pozice telesa
				tran[1]*=a;
				zdroj >> tran[2];		// pozice telesa
				tran[2]*=a;
				zdroj >> ch;			// ")"
				zdroj >> ch;			// "("
				zdroj >> rotAxis[0];	// osa rotace
				zdroj >> rotAxis[1];
				zdroj >> rotAxis[2];
				zdroj >> ch;			// ")"
				zdroj >> rot;			// rotace
				sgo = new SgObject;
				sgo->setStatic(true);
				sgo->setTypeCollision(SgObject::BALL);
				sgo->setType(SgObject::OBJECT);
				sgo->setID(countID++);
				sgo->setPos((posX*500*tunnelScale)+tran[0],(posY*500*tunnelScale)+tran[1],(posZ*500*tunnelScale)+tran[2]);
				sgo->setScale(SbVec3f(1,1,1)*tunnelScale);
				sgo->setModel(cube.c_str());
				sgo->setOrientation(rotAxis,rot*(float)M_PI);	// otocim podle souboru telesem
				//sgo->updPos(0,-250*tunnelScale-sgo->getOneAABB(1),0);
				//sgo->getOneAABB() upravit BB 
				sgoManager->appendSgo(sgo);
				zdroj >> cube;
			}
			zdroj >> cube;
			while (!(cube == "END"))	//dinamicke telesa
			{
				zdroj >> ch;			// "("
				zdroj >> tran[0];		// pozice telesa
				tran[0]*=a;
				zdroj >> tran[1];		// pozice telesa
				tran[1]*=a;
				zdroj >> tran[2];		// pozice telesa
				tran[2]*=a;
				zdroj >> ch;			// ")"
				zdroj >> ch;			// "("
				zdroj >> rotAxis[0];	// osa rotace
				zdroj >> rotAxis[1];
				zdroj >> rotAxis[2];
				zdroj >> ch;			// ")"
				zdroj >> rot;			// rotace
				sgo = new SgObject;
				sgo->setTypeCollision(SgObject::BODY);
				sgo->setType(SgObject::OTHER);
				sgo->setID(countID++);
				sgo->setPos((posX*500*tunnelScale)+tran[0],(posY*500*tunnelScale)+tran[1],(posZ*500*tunnelScale)+tran[2]);
				sgo->setSpeed(UnitRandom(5),UnitRandom(5),UnitRandom(5));
				sgo->setScale(SbVec3f(1,1,1)*tunnelScale*0.5f);
				sgo->setModel(cube.c_str());
				sgo->setOrientation(rotAxis,rot*(float)M_PI);	// otocim podle souboru telesem
				//sgo->getOneAABB() upravit BB 
				sgoManager->appendSgo(sgo);
				zdroj >> cube;
			}
		}else while (cube!="*/") zdroj>>cube;
	}

/*	sgo = new SgObject;	
	sgo->setTypeBB(SgObject::SPHERE);
	sgo->setType(SgObject::FIGHTER);
	sgo->setID(countID++);
	sgo->setSphereRadius(20);
	sgo->setPos(0.0f, -10.0f, 0.0f);
	sgo->setSpeed(0.0f, 10.0f, 0.0f);
	sgo->setScale(SbVec3f(1,1,1)*scale*3);
	sgo->setMass(100);
	sgo->setModel("Bomber.wrl");
	sgo->updOrientation(SbVec3f(0,0,1),-0.1f*M_PI);
	sgo->addLigth(pointLight);
	sgoManager->appendSgo(sgo);
*/

	sgo = new SgObject;	
	sgo->setTypeBB(SgObject::SPHERE);
	sgo->setType(SgObject::FIGHTER);
	sgo->setID(countID++);
	sgo->setSphereRadius(20);
	sgo->setPos(0.0f, 0.0f, 0.0f);
	sgo->setSpeed(0.0f, 0.0f, 0.0f);
	sgo->setScale(SbVec3f(1,1,1)*scale*3);
	sgo->setMass(100);
	sgo->setModel("Bomber.wrl");
	sgo->addLigth(pointLight);
	sgo->updOrientation(SbVec3f(0,1,0),-0.5f*M_PI);
	sgo->updOrientation(SbVec3f(0,0,1),0.5f*M_PI);
	sgoManager->appendSgo(sgo);


/*	sgo = new SgObject;	
	sgo->setTypeBB(SgObject::SPHERE);
	sgo->setType(SgObject::FIGHTER);
	sgo->setID(countID++);
	sgo->setSphereRadius(20);
	sgo->setPos(-10.0f, -10.0f, 0.0f);
	sgo->setSpeed(0.0f, 10.0f, 0.0f);
	sgo->setScale(SbVec3f(1,1,1)*scale);
	sgo->setMass(1);
	sgo->setModel("Cube.wrl",SgObject::RENDER,false );
	sgo->setModel("Cube.wrl", SgObject::COLLISION,false);
	sgo->updOrientation(SbVec3f(0,0,1),-0.1f*M_PI);
	sgo->addLigth(pointLight);
	sgoManager->appendSgo(sgo);

	sgo = new SgObject;	
	sgo->setTypeBB(SgObject::SPHERE);
	sgo->setType(SgObject::FIGHTER);
	sgo->setID(countID++);
	sgo->setSphereRadius(20);
	sgo->setPos(10.0f, -10.0f, 0.0f);
	sgo->setSpeed(0.0f, 10.0f, 0.0f);
	sgo->setScale(SbVec3f(1,1,1)*scale);
	sgo->setMass(1);
	sgo->setModel("Cube.wrl",SgObject::RENDER,false );
	sgo->setModel("Cube.wrl", SgObject::COLLISION,false);
	sgo->updOrientation(SbVec3f(0,0,1),-0.1f*M_PI);
	sgo->addLigth(pointLight);
	sgoManager->appendSgo(sgo);*/

	sgoManager->setFighterCamera(sgo);

	//objekt pro kameru (krychle)
	sgo = new SgObject;		
	sgo->setTypeBB(SgObject::SPHERE);
	sgo->setTypeCollision(SgObject::BALL);
	sgo->setType(SgObject::CAMERA);
	sgo->setID(countID++);
	sgo->setScale(SbVec3f(1,1,1));
	sgo->setMass(100);
	sgo->setModel("Camera.wrl", SgObject::COLLISION);
	sgo->setPos(0.0f, 10.0f, 20.f);
	sgo->setOrientation(SbVec3f(0,1,0),1.0*(float)M_PI);
	sgoManager->appendSgo(sgo);
	sgoManager->setFreeCamera(sgo);
	
	sgoManager->setActiveFighter();
	kameraC=16;
	kameraX=1;
	//sgoManager->setActiveFighter();
	

		//sgo = new SgObject;	
		//sgo->setTypeBB(SgObject::SPHERE);
		//sgo->setType(SgObject::FIGHTER);
		//sgo->setID(countID++);
		//cout<<"ID: "<<countID<<endl;
		//sgo->setPos(0,0,50);
		//sgo->setSpeed(0,0,-20);
		//sgo->setScale(SbVec3f(1,1,1)*0.01f);
		//sgo->setMass(10);
		//sgo->setModel("Bomber.wrl");
		//sgoManager->appendSgo(sgo);

		//sgo = new SgObject;	
		//sgo->setTypeBB(SgObject::SPHERE);
		//sgo->setType(SgObject::FIGHTER);
		//sgo->setID(countID++);
		//cout<<"ID: "<<countID<<endl;
		//sgo->setPos(0,0,60);
		//sgo->setSpeed(0,0,-20);
		//sgo->setScale(SbVec3f(1,1,1)*0.01f);
		//sgo->setMass(10);
		//sgo->setModel("Bomber.wrl");
		//sgoManager->appendSgo(sgo);

		//sgo = new SgObject;	
		//sgo->setTypeBB(SgObject::SPHERE);
		//sgo->setType(SgObject::FIGHTER);
		//sgo->setID(countID++);
		//cout<<"ID: "<<countID<<endl;
		//sgo->setPos(0,0,70);
		//sgo->setSpeed(0,0,-20);
		//sgo->setScale(SbVec3f(1,1,1)*0.01f);
		//sgo->setMass(10);
		//sgo->setModel("Bomber.wrl");
		//sgoManager->appendSgo(sgo);

		//sgo = new SgObject;	
		//sgo->setTypeBB(SgObject::SPHERE);
		//sgo->setType(SgObject::FIGHTER);
		//sgo->setID(countID++);
		//cout<<"ID: "<<countID<<endl;
		//sgo->setPos(0,0,80);
		//sgo->setSpeed(0,0,-20);
		//sgo->setScale(SbVec3f(1,1,1)*0.01f);
		//sgo->setMass(10);
		//sgo->setModel("Bomber.wrl");
		//sgoManager->appendSgo(sgo);

		//sgo = new SgObject;	
		//sgo->setTypeBB(SgObject::SPHERE);
		//sgo->setType(SgObject::FIGHTER);
		//sgo->setID(countID++);
		//cout<<"ID: "<<countID<<endl;
		//sgo->setPos(0,0,90);
		//sgo->setSpeed(0,0,-20);
		//sgo->setScale(SbVec3f(1,1,1)*0.01f);
		//sgo->setMass(10);
		//sgo->setModel("Bomber.wrl");
		//sgoManager->appendSgo(sgo);


		//sgo = new SgObject;	
		//sgo->setTypeBB(SgObject::SPHERE);
		//sgo->setType(SgObject::FIGHTER);
		//sgo->setID(countID++);
		//cout<<"ID: "<<countID<<endl;
		//sgo->setPos(0,0,100);
		//sgo->setSpeed(0,0,-20);
		//sgo->setScale(SbVec3f(1,1,1)*0.01f);
		//sgo->setMass(10);
		//sgo->setModel("Bomber.wrl");
		//sgoManager->appendSgo(sgo);

 	// Obsluha mysi
	SoEventCallback * cbmouse = new SoEventCallback;
	cbmouse->addEventCallback(SoMouseButtonEvent::getClassTypeId(), onMouseButton, NULL);
	root->insertChild(cbmouse, 0);
	// Obsluha klavesnice
	SoEventCallback * cbkeyborad = new SoEventCallback;
	cbkeyborad->addEventCallback(SoKeyboardEvent::getClassTypeId(), onKeyPress, NULL);
	root->insertChild(cbkeyborad, 0);

	SoOneShotSensor *timeStepSensor = new SoOneShotSensor(timeStep, NULL);
	timeStepSensor->schedule();

	// Vytvo renderovac okno
	#if defined(__WIN32__) || defined (_WIN32)
	renderArea = new SoWinRenderArea(window);
	#else
	renderArea = new SoQtRenderArea(window);
	#endif

	// Nastav renderovac okno
		renderArea->setSceneGraph(root);
		renderArea->setTitle("SpaceGame");
//		renderArea->setFullScreen(true);
		renderArea->show();

		renderArea->getViewportRegion();

	// Zobraz okna a rozje renderovac smyku
	#if defined(__WIN32__) || defined (_WIN32)
	SoWin::show(window);
	SoWin::mainLoop();
	#else
	SoQt::show(window);
	SoQt::mainLoop();
	#endif

	// Uvolni zdroje
	#if !defined(NDEBUG)
		delete mouse;
		delete mouseEvent;
		delete keyEvent;
	sgoManager->deteleAllSgos();
	delete sgoManager;
	delete timeStepSensor;
	delete renderArea;
	root->unref();
	SoDB::cleanup();
	#endif

	return 0;
}
