/************************************************************************

   SgInterface.cpp - interface class

   Written by Zero (xmaste00).


   THIS SOFTWARE IS NOT COPYRIGHTED

   This source code is offered for use in the public domain.
   You may use, modify or distribute it freely.

   This source code is distributed in the hope that it will be useful but
   WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
   DISCLAIMED.  This includes but is not limited to warranties of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

   If you find the source code useful, authors will kindly welcome
   if you give them credit and keep their names with their source code,
   but you are not forced to do so.

************************************************************************/

#include "SgInterface.h"

SgMouse::SgMouse() {
	//tlacitko.resize(sizeof(SoMouseButtonEvent::Button));
	tlacitko.insert(make_pair(Mouse1,SoMouseButtonEvent::BUTTON1));
	stisknuto.insert(make_pair(Mouse1,false));
	tlacitko.insert(make_pair(Mouse2,SoMouseButtonEvent::BUTTON2));
	stisknuto.insert(make_pair(Mouse2,false));
	tlacitko.insert(make_pair(Mouse3,SoMouseButtonEvent::BUTTON3));
	stisknuto.insert(make_pair(Mouse3,false));
};

void SgMouse::setButton(const SoEvent * event){
	for(Tl=tlacitko.begin();Tl!=tlacitko.end();Tl++){
		if(SoMouseButtonEvent::isButtonPressEvent(event, Tl->second)) stisknuto[Tl->first]=true;
		if(SoMouseButtonEvent::isButtonReleaseEvent(event, Tl->second)) stisknuto[Tl->first]=false;
	};
};

bool SgMouse::getButton(t_tlacitko tl){
	return stisknuto[tl];
};

SgKeyboard::SgKeyboard() {
	//{keyQ=0, keyW, keyE, keyA, keyS, keyD, keyLeft, keyRight, keyUp, keyDown, keySpace, keyCTRL, keyTAB, keyC, keyV , keyT, keyG, keyF, keyH };
	klavesa.insert(make_pair(keyQ,SoKeyboardEvent::Q));					// Q,W,E,A,S,D + arrow = ovladani pohybu stihacky
	klavesa.insert(make_pair(keyW,SoKeyboardEvent::W));
	klavesa.insert(make_pair(keyE,SoKeyboardEvent::E));
	klavesa.insert(make_pair(keyA,SoKeyboardEvent::A));
	klavesa.insert(make_pair(keyS,SoKeyboardEvent::S));
	klavesa.insert(make_pair(keyD,SoKeyboardEvent::D));
	klavesa.insert(make_pair(keyLeft,SoKeyboardEvent::LEFT_ARROW));
	klavesa.insert(make_pair(keyRight,SoKeyboardEvent::RIGHT_ARROW));
	klavesa.insert(make_pair(keyUp,SoKeyboardEvent::UP_ARROW));
	klavesa.insert(make_pair(keyDown,SoKeyboardEvent::DOWN_ARROW));
	
	klavesa.insert(make_pair(keySpace,SoKeyboardEvent::SPACE));			// ekvivalent rucni brzde
	
	klavesa.insert(make_pair(keyCTRL,SoKeyboardEvent::LEFT_CONTROL));	// left CTRL
	klavesa.insert(make_pair(keyTAB,SoKeyboardEvent::TAB));				// Tabulator (prepnuti ovladani)
	klavesa.insert(make_pair(keyM,SoKeyboardEvent::M));					// prepnuti ovladani rotace mezi klavesnici a mysi
	
	klavesa.insert(make_pair(key1,SoKeyboardEvent::NUMBER_1));			// absolutni
	klavesa.insert(make_pair(key2,SoKeyboardEvent::NUMBER_2));			// relativni s brzdenim
	klavesa.insert(make_pair(key3,SoKeyboardEvent::NUMBER_3));			// relativni

	klavesa.insert(make_pair(keyH,SoKeyboardEvent::H));					// napoveda					
	klavesa.insert(make_pair(keyF1,SoKeyboardEvent::F1));				// napoveda

	klavesa.insert(make_pair(keyF,SoKeyboardEvent::F));					// strelba
	klavesa.insert(make_pair(keyC,SoKeyboardEvent::C));					// prepnuti kamery
	klavesa.insert(make_pair(keyX,SoKeyboardEvent::X));					// prepnuti kamery
	klavesa.insert(make_pair(keyV,SoKeyboardEvent::V));					// prepnuti kamery
	klavesa.insert(make_pair(keyT,SoKeyboardEvent::T));					// tlumeni + 
	klavesa.insert(make_pair(keyR,SoKeyboardEvent::R));					// tlumeni -
	klavesa.insert(make_pair(keyG,SoKeyboardEvent::G));					// gravitace

	for (unsigned int i=0;i<klavesa.size();i++) stisknuta.insert(make_pair(t_klavesa(i),false));
};

void SgKeyboard::setKey(const SoEvent * event){
	for(Kl=klavesa.begin();Kl!=klavesa.end();Kl++){
		if(SoKeyboardEvent::isKeyPressEvent(event, Kl->second)) stisknuta[Kl->first]=true;
		if(SoKeyboardEvent::isKeyReleaseEvent(event, Kl->second)) stisknuta[Kl->first]=false;
	};
};

SgCamera::SgCamera(){
	Camera = new SoPerspectiveCamera;
	Camera->ref();
    Camera->nearDistance = 0.1f;//4;
    Camera->farDistance = 4096;
	this->distance=4;
	this->height=1;
};
SgCamera::~SgCamera(){
	Camera->unref();
};


void SgCamera::setRot(SbRotation rot){
	SbVec3f upvec(0,1,0);
	rot.multVec(upvec,upvec);
	if (!(upvec.length()>0)) upvec=SbVec3f(0,1,0);
	SbRotation pomRot=rot*SbRotation(upvec,(float)M_PI);		// otoceni kamery o 180
    this->Camera->orientation.setValue(pomRot);
	
	//SbRotation(SbVec3f(0,1,0),-0.5f*M_PI)*SbRotation(SbVec3f(0,0,1),0.5f*M_PI));
}

void SgCamera::setPos(SbVec3f pos){
	SbVec3f lookat(0,this->height,this->distance);
	SbRotation rot = this->Camera->orientation.getValue();
	rot.multVec(lookat,lookat);
	if (!(lookat.length()>0)) lookat=SbVec3f(0,this->height,this->distance);
	this->Camera->position.setValue(pos+lookat);
	//this->Camera->position.setValue(pos);
}
SgPointLight::SgPointLight()
{
	Light = new SoPointLight;
	Light->color =  SbVec3f(1.0f, 1.0f, 1.0f);
	Light->location = SbVec3f(0,0,0);
	Light->intensity = 1;
}
void SgPointLight::setRoot(SoSeparator * root)
{ 
	root->addChild(this->Light); 
}
void SgPointLight::setPos(SbVec3f pos)
{
	this->Light->location.setValue(pos);
}
SgConeLight::SgConeLight()
{
	Light = new SoSpotLight;
	Light->color =  SbVec3f(1.0f, 1.0f, 1.0f);
	Light->location = SbVec3f(0,0,0);
	Light->direction = SbVec3f(0,0,-1);
	Light->intensity = 1;
	Light->dropOffRate = 0;
	Light->cutOffAngle = float (M_PI/4.0f);
}
void SgConeLight::setRoot(SoSeparator * root)
{ 
	root->addChild(this->Light); 
}
void SgConeLight::setPos(SbVec3f pos)
{
	this->Light->location.setValue(pos);
}
void SgConeLight::setDir(SbVec3f dir)
{
	this->Light->direction.setValue(dir);
}
