#ifndef SG_INTERFACE_H_ZERO
#define SG_INTERFACE_H_ZERO
/************************************************************************

   SgInterface.h - interface class

   Written by Zero (xmaste00).


   THIS SOFTWARE IS NOT COPYRIGHTED

   This source code is offered for use in the public domain.
   You may use, modify or distribute it freely.

   This source code is distributed in the hope that it will be useful but
   WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
   DISCLAIMED.  This includes but is not limited to warranties of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

   If you find the source code useful, authors will kindly welcome
   if you give them credit and keep their names with their source code,
   but you are not forced to do so.

************************************************************************/

#include "MainInclude.h"

enum t_tlacitko{Mouse1=0, LeftB=0, Mouse2=1, MiddleB=1, Mouse3=2, RightB=2};
enum t_klavesa {keyQ=0, keyW, keyE, keyA, keyS, keyD, 
				keyLeft, keyRight, keyUp, keyDown, 
				keySpace, keyCTRL, keyTAB, keyM, 
				keyX, keyC, keyV, keyT, keyR, keyG, keyF, keyH,
				key1, key2, key3,
				keyF1};

class SgMouse	// trida pro mys
{
protected:
	map <t_tlacitko, SoMouseButtonEvent::Button> tlacitko;		// mapa (kontejner) tlacitek
	map <t_tlacitko, SoMouseButtonEvent::Button>::iterator Tl;	// iterator v mape
	map <t_tlacitko, bool> stisknuto;		// seznam stisknutych tlacitek
	map <t_tlacitko, bool>::iterator St;	// iterator do mapy
public:
	SgMouse();
	void setButton (const SoEvent * event);	// nastaveni tlacitka
	bool getButton (t_tlacitko tl);			// zyskani hodnoty tlacitka
};

class SgKeyboard	// trida pro klavesnici
{
protected:
	map <t_klavesa, SoKeyboardEvent::Key> klavesa;		// mapa klaves
	map <t_klavesa, SoKeyboardEvent::Key>::iterator Kl;	// iterator
	map <t_klavesa, bool> stisknuta;		// mapa stisknutych klaves
	map <t_klavesa, bool>::iterator St;		// iterator

public:
	SgKeyboard();
	void setKey (const SoEvent * event);					// nastaveni klavesy
	bool getKey (t_klavesa key) { return stisknuta[key]; }	// zyskani kavesy
	void falseKey (t_klavesa key) { stisknuta[key]=false; }	// prirazeni false do klavesy
	void trueKey (t_klavesa key) { stisknuta[key]=true; }	// prirazeni tzrue do klavesy
};

class SgCamera		// trida pro kameru
{
protected:
	SoPerspectiveCamera * Camera;
	float distance;		//vzdalenost kamery od objektu
	float height;		//vyska kamery od objektu

public:
    SgCamera();
	~SgCamera();
	SoPerspectiveCamera * getRoot() { return Camera; }

	void setRot(SbRotation rot);	//nejprve nastavit rotaci, podle ni se pocita pozice
	void setPos(SbVec3f pos);		//opacne bude skakat kamera
	void setDistance(float d) { this->distance=d; }	// nastaveni vzdalenosti
	void setHeight(float h) { this->height=h; }		// nastaveni vysky kamery
};
class SgLight		// trida pro svetla
{
protected:
public:
	virtual void setRoot(SoSeparator * root) {};
	virtual void setPos(SbVec3f pos) {};
	virtual void setDir(SbVec3f pos) {};
};
class SgPointLight:public SgLight	// bodove svetlo
{
protected:
	SoPointLight * Light;
public:
	SgPointLight();
	void setRoot(SoSeparator * root);
	void setPos(SbVec3f pos);
	void setDir(SbVec3f dir) {}
};
class SgConeLight:public SgLight	// kuzelove svetlo
{
protected:
	SoSpotLight * Light;
public:
	SgConeLight();
	void setRoot(SoSeparator * root);
	void setPos(SbVec3f pos);
	void setDir(SbVec3f dir);
};
#endif /* SG_INTERFAC_H */